
#include "GCMain.h"

////////////////////////////////////////////////////

void *recv_message( void *arg );
void *player( void *arg );

char message[BUFSIZE];

FILE *fp;

////////////////////////////////////////////////////

void *recv_message(void * arg)
{
	GCMain *gc = (GCMain*)arg;
	int sock = gc->getSock();;

	ssize_t nbytes;
	printf("read start!\n");
	
	while(1) {
		nbytes = mrecvmsg( sock, message, BUFSIZE, 0, NULL, NULL );
		if( nbytes <= 0 )
			break;

		fwrite( message, 1, nbytes, fp );
	}

	gc->setButton();

	return 0;
}


void *player( void *arg )
{
	sleep(1);
	system( "mplayer result.avi" );
	return 0;
}


GCMain::GCMain()
{
	setGeometry( 100, 100, 400, 400 );

	this->setCaption( "ECTP(LE)" );
	v1 = new QVBoxLayout(this);
	h1 = new QHBoxLayout(v1);


	box = new QGroupBox( 2, Horizontal, "Address", this );

	label1 = new QLabel( "TO IP", box );
	to_ip = new QLineEdit(box);
	to_ip->setText("155.230.24.145");

	label3 = new QLabel( "Group IP", box );
	mul_ip = new QLineEdit(box);
	mul_ip->setText("226.0.0.1");

	label4 = new QLabel( "Group PORT", box );
	mul_port = new QLineEdit(box);
	mul_port->setText("9926");
	

	p_ljr = new QPushButton( "Late Join", box );
	v1->addWidget(box);

	vbg = new QVButtonGroup( "Event", this );

	button[0] = new QPushButton( "Token Get Request", vbg );
	button[0]->setEnabled(false);
	button[1] = new QPushButton( "Token Return Request", vbg );
	button[1]->setEnabled(false);
	button[2] = new QPushButton( "User Leave Request", vbg );
	button[2]->setEnabled(false);
	v1->addWidget(vbg);

	token_box = new QGroupBox( 2, Horizontal, "Token", this );

	token_msg = new QLineEdit(token_box);
	token_msg->setReadOnly(true);
	send_token = new QPushButton( "Send", token_box );
	send_token->setEnabled(false);
	v1->addWidget(token_box);

	connect( p_ljr, SIGNAL(clicked()), this, SLOT(lateJoin()) );
	connect( vbg, SIGNAL(clicked(int)), this, SLOT(onClick(int)) );
	connect( send_token, SIGNAL(clicked()), this, SLOT(sendToken()) );

	esd = 0;
}

GCMain::~GCMain()
{
}

int GCMain::getSock()
{
	return esd;
}

void GCMain::setButton()
{
	p_ljr->setEnabled(false);
	button[0]->setEnabled(false);
	button[1]->setEnabled(false);
	button[2]->setEnabled(false);
	token_msg->setReadOnly(true);
	send_token->setEnabled(false);
}

void GCMain::error_handling( char *message )
{
	fputs( message, stderr );
	fputc( '\n', stderr );
	perror( "Error " );
	exit(1);
}

void GCMain::lateJoin()
{
	pthread_t recv_thread, play_thread;

	local_ip = to_ip->text().ascii();
	group_ip = mul_ip->text().ascii();
	group_port = mul_port->text().toInt();
	printf( "Local : IP = %s\n", local_ip );
	printf( "Group : IP = %s, Port = %d\n", group_ip, group_port );

	if( !(fp = fopen( "result.avi", "w" )) )
		error_handling( "Open() error" );
	printf( "create..... result.avi\n" );

	/* TO address & Group port assignment. */
	memset( &local_addr, 0, sizeof(local_addr) );
	local_addr.sin_family = AF_INET;
	local_addr.sin_addr.s_addr = inet_addr(local_ip);
	local_addr.sin_port = htons(group_port);

	/* Group address & Group port assignment. */
	memset( &group_addr, 0, sizeof(group_addr) );
	group_addr.sin_family = AF_INET;
	group_addr.sin_addr.s_addr = inet_addr(group_ip);
	group_addr.sin_port = htons(group_port);

	/* ECTP-3 API - msocket() */
	if( (esd = msocket(PF_INET, ECTP_ROLE_LE)) < 0 )
		error_handling( "msocket() error" );

	/* ECTP-3 API - mjoin() */
	if( mjoin(esd, (struct sockaddr_storage *) &local_addr, (struct sockaddr_storage *) &group_addr, 0) < 0 )
		error_handling( "mjoin() error!" );


	p_ljr->setEnabled(false);
	button[0]->setEnabled(true);
	button[2]->setEnabled(true);

	pthread_create( &recv_thread, NULL, recv_message, (void*)this );
	pthread_create( &play_thread, NULL, player, (void*)esd );
}

void GCMain::sendToken()
{
	const char *msg = NULL;
	msg = token_msg->text().ascii();
	if ( strlen(msg) > 0 ) {
	printf( "Token Msg : %s\n", msg );
	msendmsg( esd, msg, strlen(msg), 0, 
			(struct sockaddr_storage*)&local_addr, sizeof(local_addr) );
	}
	token_msg->clear();
}

void GCMain::onClick( int nButton )
{
	int token_id;
	switch(nButton) {
		case 0:
			printf( "Token Get Request\n" );
			token_id = mtoken_get(esd);
			if ( token_id > 0 )
				printf( "Token Get Confirm - Token ID : %d\n", token_id );

			button[0]->setEnabled(false);
			button[1]->setEnabled(true);
			token_msg->setReadOnly(false);
			send_token->setEnabled(true);
			break;
		case 1:
			printf( "Token Return Request\n" );
			mtoken_return(esd);

			button[0]->setEnabled(true);
			button[1]->setEnabled(false);
			token_msg->setReadOnly(true);
			send_token->setEnabled(false);
			break;
		case 2:
			printf( "User Leave Request\n" );
			mleave( esd, NULL, 0 );

			p_ljr->setEnabled(true);
			button[0]->setEnabled(false);
			button[1]->setEnabled(false);
			button[2]->setEnabled(false);
			token_msg->setReadOnly(true);
			send_token->setEnabled(false);
			break;
	}
}

int main( int argc, char **argv )
{
	QApplication qApp(argc, argv);
	GCMain *ectp = new GCMain;
	QSize size = ectp->sizeHint();
	ectp->setMinimumSize(size);
	ectp->setMaximumSize(size);

	ectp->show();

	qApp.setMainWidget(ectp);
	return qApp.exec();
}
